﻿/*  
 * Autor: 3lit www.hacks4.me
 * 23.11.2009
 * 
 * Read LICENSE.txt
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Net.Sockets;
using System.Threading;
using System.IO;
using System.Net;

namespace H4MInjection 
{

    public class Connection 
    {

        private NetworkStream Stream;
        private TcpListener _TcpListener;
        private TcpClient _TcpClient;

        private Thread _Worker;

        public delegate void Recive(string Message);
        public event Recive ReciveEvent;

        public Connection(int Port) {
            _TcpListener = new TcpListener(IPAddress.Any, Port);

            new Thread(Listen).Start();
        }

        private void Listen() {
            try {
                _TcpListener.Start();

                _TcpClient = _TcpListener.AcceptTcpClient();

                Stream = _TcpClient.GetStream();
            }
            catch { }

            _Worker = new Thread(Worker);
            _Worker.Start();
        }

        private void Worker() {
            StreamReader _StreamReader = new StreamReader(Stream);

            while (Stream != null) {
                try {
                    byte[] Bytes = new byte[1024];
                    int i = Stream.Read(Bytes, 0, Bytes.Length);
                    string Recive = Encoding.Default.GetString(Bytes);

                    if (ReciveEvent != null) {
                        ReciveEvent(Recive);
                    }
                }
                catch { }
            }
        }

        public void Send(string Message) {
            Message = Message.Replace("\0", "*");
            try {
                StreamWriter _StreamWriter = new StreamWriter(Stream);
                _StreamWriter.WriteLine(Message);
                _StreamWriter.Flush();
            }
            catch { }
        }

        public void Disconnect() {
            _TcpClient.Close();
            _TcpListener.Stop();
            _Worker.Abort();
        }

    }
}
