﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using H4MInjection;

namespace H4MInjectionSample
{
    public partial class Form1 : Form
    {
        private Injection _Injection;
        private string Channel;

        public Form1() {
            InitializeComponent();
        }

        private void btnStart_Click( object sender, EventArgs e ) {
            _Injection = new Injection();
            _Injection.Client( "chat.knuddels.de", 2710 );
            _Injection.ReciveEvent += new Injection.Recive( Receive );
        }

        private void btnStop_Click( object sender, EventArgs e ) {
            _Injection.Kill();
        }

        private void tbInput_KeyDown( object sender, KeyEventArgs e ) {
            if( e.KeyCode == Keys.Enter ) {
                _Injection.Send( "e\0" + Channel + "\0" + tbInput.Text );
                tbInput.Clear();
            }
        }

        public void Receive( string Message ) {
            string[] token = Message.Split( '\0' );

            switch( token[0] ) {
                case "a":
                    Channel = token[1];
                    break;

                case "j":
                    Channel = token[1];
                    break;

                case "e":
                    richTextBox1.AppendText( token[1] + ": " + token[3] );
                    richTextBox1.ScrollToCaret();
                    break;
            }
        }
    }
}
